<?
//start a session and get a session ID to identify "my" tables and views in the database
if(session_id() == "") 
{ 
session_start(); 
} 
$theid = session_id();


// database access parameters
$host = "c-6008";
$user = "webuser";
$pass = "pgonline";
$db = "pgonline";
$port = "5433";
// open a connection to the database server
$connection = pg_connect ("host=$host dbname=$db user=$user password=$pass port=$port");
if (!$connection)
{
	die("Could not open connection to database server");
}


$type='view';
//Map1, Map2 or Map3
$themap = $HTTP_POST_VARS["whatmap"];
$bgmap=$HTTP_POST_VARS["bg"];
	//the last extent of the map
	$lastbbox = $HTTP_POST_VARS["lastbbox"];



	$thesql = $HTTP_POST_VARS["thesql"];

	//drop old views tables and sequences with this sessionid
	pg_query($connection, "drop view if exists  " . $themap.$theid. "; drop table if exists  " . $themap.$theid. "; drop SEQUENCE if exists ".$themap.$theid."_seq;") or die("problem");
	//Put a new session timestamp
	pg_query($connection, "delete from sessions where session = '".$theid."';insert into sessions(session) values('".$theid."');") or die("problem");
	//create a new sequence to use for unique values in view
	pg_query($connection, "CREATE SEQUENCE " . $themap.$theid."_seq;") or die("problem");

	//put in the sequence in the sql-string
	$thesql = str_ireplace("select", "select nextval('".$themap.$theid."_seq')::integer as num, ", $thesql);

	//remove \ automatically inserted when sent from form. This is probably a bad way of solving it.
	$thesql = str_ireplace("\'", "'", $thesql);

	//create the view or table

	$query = " create ".$type." ".$themap.$theid." as " . $thesql;
	$result = pg_query($connection, $query) or die("problem");

	//time to check what we have got
	//first we check srid and typ
	//theis should be rewritten, now it only checks first row
	$sridtypesql =  "select st_srid(the_geom) as srid, geometrytype(the_geom) as type from userdata.". $themap.$theid . " limit 1;";
	$sridtypeq = pg_query($connection, $sridtypesql) or die("problem");

	$row = pg_fetch_row($sridtypeq, 0, PGSQL_ASSOC);
	$srid= $row['srid'];

	if(($row['type']=="MULTIPOLYGON") or ($row['type']=="POLYGON"))
	  {
		$type='polygon';
	  }
	elseif(($row['type']=="MULTILINESTRING") or ($row['type']=="LINESTRING"))
	  {
		$type='line';
	  }
	elseif(($row['type']=="MULTIPOINT") or ($row['type']=="POINT"))
		{    $type='point';
	}

//Map1 decides the extent of the map so if we are handling map1 we have to check the extent, the check for lastbbox here is if the backgroudmap is requested before Map1
if ($themap=="Map1"||strlen($lastbbox)==0)
{
	$extentsql = "with a as (select st_expand(st_extent(the_geom)::box2d,10) as ext from ".$themap.$theid.") select st_xmax(ext) as xmax,st_ymax(ext) as ymax,st_xmin(ext) as xmin,st_ymin(ext) as ymin from a ";
	$extentq = pg_query($connection, $extentsql) or die("problem");
	$row = pg_fetch_row($extentq, 0, PGSQL_ASSOC);
	$MAPEXT  = $row['xmin']." ".$row['ymin']." ".$row['xmax']." ".$row['ymax'];
}
else
{
	//if not Map1 or solely background we just reuse the old extent
	$MAPEXT = $lastbbox;
}

//we drop all old maps in db. Those which session id has not been used for a certain time  
pg_query($connection, "select drop_old();") or die("problem");

//Done, let's move on to mapserver
$to = 'http://'.$host.'/cgi-bin/mapserv.exe?map=C:\OSGeo4W/apps/postgis/main.map';
$to = $to.'&mode=browse';
$to = $to.'&MAPEXT='.$MAPEXT;
$to = $to.'&db='.$db;
$to = $to.'&layer='.$type.$themap;
$to = $to.'&relation='.$themap.$theid;
$to = $to.'&srid='.$srid;
$to = $to.'&type='.$type;
$to = $to.'&mapnr='.$themap;
header('Location: '. $to); 

// close database connection
pg_close($connection);
exit;
?>