-- this is needed to delete tables, views and sequensis whith suffix including old unused sessions from table sessions





CREATE OR REPLACE FUNCTION userdata.exec(text)
  RETURNS void AS
$BODY$  begin execute $1; end; $BODY$ 
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION userdata.exec(text) OWNER TO webuser;


CREATE OR REPLACE FUNCTION userdata.drop_old()
  RETURNS void AS
$BODY$ 

DECLARE
justnow timestamp with time zone := now();
toleranceOfAge interval :='00:30:00'::interval;
begin


 perform exec('drop view if exists userdata.' || quote_ident(viewname) || ' cascade') from pg_views a where schemaname ='userdata' and 
substr(a.viewname,5,char_length(a.viewname)-4) not in (select session from sessions where (justnow-lasttime) < toleranceOfAge) ; 

 perform exec('drop view if exists userdata.' || quote_ident(tablename) || ' cascade') from pg_tables a where schemaname ='userdata' and 
substr(a.tablename,5,char_length(a.tablename)-4) not in (select session from sessions where (justnow-lasttime) < toleranceOfAge) ; 

 perform exec('drop sequence if exists userdata.' || quote_ident(relname) || ' cascade') from pg_statio_all_sequences a where schemaname ='userdata' and 
substr(a.relname,5,char_length(a.relname)-4) not in (select session||'_seq' as totname from sessions where (justnow-lasttime) < toleranceOfAge) ; 

delete from sessions where (justnow-lasttime) > toleranceOfAge; 

end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION userdata.drop_old() OWNER TO webuser;
