
-- a try to set search_path and grants for the application
--should be complemented with revokes where the user shouldn't have rights

SET search_path TO 'userdata', 'rawdata','adm', 'public';
alter user webuser set search_path='userdata', 'rawdata','adm', 'public';


GRANT insert ON TABLE sessions TO webuser;
GRANT select ON TABLE sessions TO webuser;


GRANT usage ON schema rawdata TO webuser;
GRANT usage ON schema adm TO webuser;
GRANT create ON schema userdata TO webuser;

GRANT SELECT ON TABLE spatial_ref_sys TO webuser;


-- Should be ran for each new table added in schema rawdata
--GRANT SELECT ON TABLE rawdata.tablename TO webuser;
GRANT SELECT ON TABLE rawdata.polygon TO webuser;